/*
 * Dan Aloni <da-x@colinux.org>, 2005 (c)
 *
 * The code is licensed under the GPL. See the COPYING file at
 * the root directory.
 */

/*
 * Kernel-space interface to upmfs.
 */ 

#ifndef _LINUX_UPM_FS_I_H
#define _LINUX_UPM_FS_I_H

#define UPMFS_MAGIC              0x50495046

#ifdef __KERNEL__

struct upm_inode_info {
	unsigned int offset;
	struct file *wrapped_file;
};

/* Differs from UPM_BUF in that UPM_SIZE is the length of the actual
   memory allocation, whereas UPM_BUF makes atomicity guarantees.  */
#define UPM_SIZE		PAGE_SIZE
#define UPM_INFO(inode)         ((struct upm_inode_info *)((inode)->i_pipe))

struct file *upm_get_unaligned_map(struct file *wrapped_file, unsigned long offset);

#endif

#endif
